
LSUpgradeEvent = {};
LSUpgradeEvent_mt = Class(LSUpgradeEvent, Event);
InitEventClass(LSUpgradeEvent, "LSUpgradeEvent");

function LSUpgradeEvent:emptyNew()
	local self = Event:new(LSUpgradeEvent_mt);
	return self;
end;

function LSUpgradeEvent:new(vehicle, name, level)

	local self = LSUpgradeEvent:emptyNew();
	self.vehicle = vehicle;
	self.name = name;
	self.level = tonumber(level);
  
	return self;
end;

function LSUpgradeEvent:readStream(streamId, connection)

	local id = streamReadInt32(streamId)
	self.vehicle = networkGetObject(id);
	self.name = streamReadString(streamId);
	self.level = streamReadInt32(streamId);
	
	self:run(connection);
end;

function LSUpgradeEvent:writeStream(streamId, connection)

	local id = networkGetObjectId(self.vehicle)
	streamWriteInt32(streamId, id);
	streamWriteString(streamId, self.name);
	streamWriteInt32(streamId, self.level);

end;

function LSUpgradeEvent:run(connection)
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, true);
	else
		if self.vehicle ~= nil then
			
			for key, upgrade in pairs (self.vehicle.upgrades) do
			
				if upgrade.name == self.name then

					upgrade.level = self.level;
					upgrade.refreshDisplay = true;
					break;
				end;
			end;
			
			self.vehicle:updateUpdgrade(false);
		end;
	end;
end;
